[tox]
envlist = py38
minversion = 3.18.0
install_command =
    python -I -m pip install -U {opts} {packages}


[testenv:py{38,39,310,311,312}]
description =
    "Default job, running all kinds of tests."
extras =
    all,tests
allowlist_externals =
    bash
commands=
    bash scripts/run_tests.sh lint_code
    bash scripts/run_tests.sh lint_tests
    bash scripts/run_tests.sh run_tests {posargs}
set_env =
    TF_FORCE_GPU_ALLOW_GROWTH=true  # prevent TensorFlow GPU pre-allocation
    XLA_PYTHON_CLIENT_PREALLOCATE=false  # prevent Jax GPU pre-allocation


[testenv:py{38,39,310,311,312}-ci]
description =
    "CI-runner-adjusted job, running all kinds of tests."
extras =
    all,tests
allowlist_externals =
    bash
commands =
    bash scripts/run_tests.sh lint_code
    bash scripts/run_tests.sh lint_tests
    bash scripts/run_tests.sh run_tests {posargs}
set_env =
    TF_FORCE_GPU_ALLOW_GROWTH=true  # prevent TensorFlow GPU pre-allocation
    XLA_PYTHON_CLIENT_PREALLOCATE=false  # prevent Jax GPU pre-allocation


[testenv:py{38,39,310,311,312}-tests]
description =
    "Individualized job to run unit and integration tests."
extras =
    all,tests
allowlist_externals =
    bash
commands=
    bash scripts/run_tests.sh run_tests {posargs}
set_env =
    TF_FORCE_GPU_ALLOW_GROWTH=true  # prevent TensorFlow GPU pre-allocation
    XLA_PYTHON_CLIENT_PREALLOCATE=false  # prevent Jax GPU pre-allocation


[testenv:py{38,39,310,311,312}-lint_code]
description =
    "Individualized job to run source code static analysis."
extras =
    all,tests
allowlist_externals =
    bash
commands =
    bash scripts/run_tests.sh lint_code


[testenv:py{38,39,310,311,312}-lint_tests]
description =
    "Individualized job to run test code static analysis."
extras =
    all,tests
allowlist_externals =
    bash
commands =
    bash scripts/run_tests.sh lint_tests
